package org.maltparser.core.dataformat.reader;

import java.io.InputStreamReader;
import java.net.URL;

import org.maltparser.core.exception.MaltChainedException;

/**
 *  
 *
 * @author Johan Hall
 * @since 1.0
**/
public interface DataReader {
	public void initialize(String fileName, String charsetName) throws MaltChainedException;
	public void initialize(URL url) throws MaltChainedException;
	public void initialize(InputStreamReader isr) throws MaltChainedException;
	public void readProlog() throws MaltChainedException;
	public boolean readSentence() throws MaltChainedException;
	public void readEpilog() throws MaltChainedException;
	public int getSentenceCount() throws MaltChainedException;
	public void close() throws MaltChainedException;
}
