package org.maltparser.core.graph.arc;

import java.util.SortedSet;

import org.maltparser.core.graph.Node;
import org.maltparser.core.symbol.SymbolTable;
/**
 *  
 *
 * @author Johan Hall
 * @since 1.0
**/
public interface HeadArcs {
	public void clear();
	
	public void addHead(Node head, ArcLabels arcLabelCodes);
	public boolean hasHead();
	public Node getHead(); // first head
	public Node getHead(int index);
	public SortedSet<Node> getHeads();
	
	public ArcLabels getArcLabels(int headindex);
	public ArcLabels getFirstHeadArcLabels();
	public Integer getLabelCode(int headindex, SymbolTable table);
	public Integer getLabelCode(Node head, SymbolTable table);
	public Integer getFirstHeadLabelCode(SymbolTable table);
	public boolean isSingleHeaded();
	public boolean hasLabelCodes();
	
}
