package org.maltparser.core.sentence;

import org.maltparser.core.dataformat.ColumnDescription;
import org.maltparser.core.exception.MaltChainedException;

/**

@author Johan Hall
@since 1.0
*/
public abstract class ColumnInstance implements Comparable<ColumnInstance>{
	protected ColumnDescription columnDescription;
	protected boolean known;
	
	public ColumnInstance(ColumnDescription columnDescription, boolean known) {
		setColumnDescription(columnDescription);
		this.known = known;
	}
	
	public ColumnDescription getColumnDescription() {
		return columnDescription;
	}

	public void setColumnDescription(ColumnDescription column) {
		this.columnDescription = column;
	}
	
	public boolean isOracleFeature() {
		if (columnDescription.getCategory() == ColumnDescription.HEAD || columnDescription.getCategory() == ColumnDescription.OUTPUT) {
			return true;
		} else {
			return false;
		}
	}

	public boolean isKnown() {
		return known;
	}
	
	public int compareTo(ColumnInstance o) {
		return columnDescription.compareTo(o.getColumnDescription());
	}

	public abstract void setValue(String v) throws MaltChainedException;
	public abstract int getIntegerValue();
	public abstract String getStringValue() throws MaltChainedException;
}
