package org.maltparser.parser.algorithm.covington;

import org.maltparser.core.config.SingleMaltConfiguration;
import org.maltparser.core.exception.MaltChainedException;
import org.maltparser.core.graph.DependencyGraph;
import org.maltparser.core.sentence.Sentence;

/**
 * 
 * @author Joakim Nivre
 * @author Johan Hall
 * @since 1.0
*/
public class CovingtonNonProjective extends Covington {

	public CovingtonNonProjective(SingleMaltConfiguration configuration, Sentence sentence) throws MaltChainedException {
		super(configuration, sentence);
	}
	
	protected void updateLeft(DependencyGraph dg, int trans) {
		if (trans == SHIFT) {
			left = leftstop - 1;
		} else { 
			left--;
			while (left >= leftstop) {
				if (input.get(right).findComponent().getIndex().intValue() != input.get(left).findComponent().getIndex().intValue() &&
						!(input.get(left).hasHead() && input.get(right).hasHead())) {
					break;
				}
				left--;
			}
		}
	}
	
	public String getName() {
		return "covnonproj";
	}
}